/**
 * Bipartite Matching
 *
 * Complexity (Time): O(V*E)
 * Complexity (Space): O(V*E)
 */

vector<int> graph[MAX];
int cont[MAX], match[MAX];

/**
 * Finds match for x.
 * @param x starting vertex
 */
int dfs(int x) {
  if (cont[x])
    return 0;

  cont[x] = 1;
  for (auto i : graph[x])
    if (match[i] == -1 || dfs(match[i])) {
      match[i] = x;
      return 1;
    }

  return 0;
}

/**
 * Returns number of left elements in matching and fills match array with the 
 * match itself (match[right_i] = left_i).
 * @param n number of vertices on the left
 */
int bipartite_matching(int n) {
  int ans = 0;
  mset(match, -1);

  for (int i = 0; i < n; ++i) {
    mset(cont, 0);
    ans += dfs(i);
  }

  return ans;
}
