/**
 * Dijkstra
 *
 * Complexity (Time): O(E + V log V)
 * Complexity (Space): O(V + E)
 */

int dist[MAX];
vector<ii> graph[MAX];

/**
 * Returns shortest distance from s to d
 * @param s,d origin and destination vertices
 */
int dijkstra(int s, int d) {
  set<ii> pq;
  int u, v, wt;

  mset(dist, inf);

  dist[s] = 0;
  pq.insert(ii(0, s));

  while (pq.size() != 0) {
    u = pq.begin()->second;
    pq.erase(pq.begin());

    for (auto i : graph[u]) {
      v = i.first;
      wt = i.second;

      // If the distance to v can be improved from d, improve it
      if (dist[v] > dist[u] + wt) {

        // Erase v from pq, because the distance was updated, if 
        // the distance is inf, then v is not on pq
        if (dist[v] != inf)
          pq.erase(pq.find(ii(dist[v], v)));

        dist[v] = dist[u] + wt;
        pq.insert(ii(dist[v], v));
      }
    }
  }

  return dist[d];
}
