/**
 * Floyd Warshall Algorithm
 *
 * Complexity (Time): O(V^3)
 * Complexity (Space): O(V^2)
 */

int dist[MAX][MAX];
int graph[MAX][MAX];

/**
 * Computes shortest path between all pairs of vertices.
 * @param n number of vertices
 */
int floyd_warshall(int n) {
  for (int i = 0; i < n; ++i)
    for (int j = 0; j < n; ++j)
      dist[i][j] = graph[i][j];

  for (int k = 0; k < n; ++k)
    for (int i = 0; i < n; ++i)
      for (int j = 0; j < n; ++j)
        dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j])
}
