/**
 * Prim
 *
 * Complexity (Time): O(E log E)
 * Complexity (Space): O(V + E)
 */

bool cont[MAX];
vector<ii> graph[MAX];

/**
 * Returns value of MST of graph.
 */
int prim() {
  mset(cont, false);
  cont[0] = true;

  // Add negative values to pq in order to give priority
  // to the edge with the smallest weight
  priority_queue<ii> pq;
  for (auto i : graph[0])
    pq.push(ii(-i.se, -i.fi));

  // At each step, connect vertex with smallest weight to the MST
  int ans = 0;
  while (!pq.empty()) {
    ii front = pq.top(); pq.pop();
    int u = -front.se;
    int w = -front.fi;

    if (!cont[u]) {
      ans += w;
      cont[u] = true;

      for (auto i : graph[u])
        if (!cont[i.fi])
          pq.push(ii(-i.se, -i.fi));
    }
  }

  return ans;
}
