/**
 * Binary Exponentiation
 *
 * Complexity (Time): O(log n)
 * Complexity (Space): O(1)
 */

/**
 * Returns x^n in O(log n) time
 * @param x number
 * @param n exponent
 */
template <typename T>
T fast_pow(T x, ll n) {
  T ans = 1;

  while (n) {
    if (n & 1)
      ans = ans * x;

    n >>= 1;
    x = x * x;
  }

  return ans;
}
