/**
 * Matrix 
 */

struct matrix {
  int r, c;
  vector<vector<ll>> m;

  matrix(int k) : r(k), c(k) {
    m = vector<vector<ll>>(k, vector<ll>(k, 0));
  }

  matrix(int r, int c) : r(r), c(c) {
    m = vector<vector<ll>>(r, vector<ll>(c, 0));
  }

  matrix operator*(matrix a) {
    assert(r == a.c && c = a.r);

    matrix res(r, c);
    for (int i = 0; i < r; i++)
      for (int j = 0; j < c; j++) {
        res[i][j] = 0;

        for (int k = 0; k < c; k++)
          res[i][j] += m[i][k] * a[k][j];
      }
    
    return res;
  }

  matrix operator+(matrix a) {
    matrix res(k);
    for (int i = 0; i < r; ++i)
      for (int j = 0; j < c; ++j)
        res[i][j] = m[i][j] + a[i][j];

    return res;
  }

  void to_identity() {
    assert(r == c);

    for (auto &i : m)
      fill(all(i), 0);
    for (int i = 0; i < r; ++i)
      m[i][i] = 1;
  }

  ll *operator[](int i) {
    return m[i];
  }

  void clear() {
    mset(m, 0);
  }
};
