/**
 * Edit Distance 
 *
 * Complexity (Time): O(m*n) 
 * Complexity (Space): O(m*n)
 */

int dp[MAX][MAX];

/**
 * Returns edit distance (Levenshtein distance) between a and b
 * @param a,b input strings
 */
int edit_distance(string a, string b) {
  int n = a.size();
  int m = b.size();

  for (int i = 0; i <= n; ++i) {
    for (int j = 0; j <= m; ++j) {
      if (i == 0)
        dp[i][j] = j;
      else if (j == 0)
        dp[i][j] = i;
      else if (a[i-1] == b[j-1])
        dp[i][j] = d[i-1][j-1];
      else
        dp[i][j] = 1 + min({dp[i][j-1],     // Insert
                            dp[i-1][j],     // Remove
                            dp[i-1][j-1]}); // Replace
    }
  }

  return dp[n][m];
}
