/**
 * Binary Indexed Tree (BIT)
 *
 * Complexity (Time):
 *   Update -> O(log n)
 *   Query  -> O(log n)
 * Complexity (Space): O(n)
 */

int tree[MAX];

/**
 * Performs query in array (tree) in the idx position.
 */
int query(int idx) {
  int sum = 0;
  for (; idx > 0; idx -= (idx & -idx))
    sum += tree[idx];

  return sum;
}

/**
 * Adds a value (val) to a single position (idx) in the array (tree).
 */
void update(int idx, int val) {
  for (; idx <= MAX; idx += (idx & -idx))
    tree[idx] += val;
}
