#include <bits/stdc++.h>

#define EPS 1e-6
#define MOD 10000
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define sz size()
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

typedef long long ll;
typedef pair<int,int> ii;

#define K 2

template <typename T>
struct matrix {
  T m[K][K];

  // Matrix multiplication - O(k^3)
  matrix operator*(matrix a) {
    matrix aux;

    for (int i = 0; i < K; i++)
      for (int j = 0; j < K; j++) {
        ll sum = 0;

        for (int k = 0; k < K; k++)
          sum += (m[i][k] * a[k][j]) % MOD;

        aux[i][j] = sum % MOD;
      }
    
    return aux;
  }

  T *operator[](int i) {
    return m[i];
  }

  void clear() {
    mset(m, 0);
  }
};


// Fast exponentiation (can be used with integers as well) - O(log n)
matrix<ll> matrix_pow(matrix<ll> in, ll n) {
  matrix<ll> ans, b = in;

  // Set ans as identity matrix
  ans.clear();
  for (int i = 0; i < K; ++i)
    ans[i][i] = 1;

  while (n) {
    if (n & 1)
      ans = ans * b;

    n >>= 1;
    b = b * b;
  }

  return ans;
}


// Solves f(n) = x * f(n - 1) + y * f(n - 2)
matrix<ll> solve(ll x, ll y, ll n) {
  matrix<ll> in;

  in[0][0] = x % MOD;
  in[0][1] = y % MOD;
  in[1][0] = 1;
  in[1][1] = 0;

  return matrix_pow(in, n);
}


int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  ll a, b, n, k; cin >> a >> b >> n >> k;

  matrix<ll> ans = solve(2 * a, (b - a * a) + MOD, n - 1);
  ll res = (ans[0][0] * 2 * a + ans[0][1] * 2) % MOD;

  if (a * a > b || (a * a < b && n % 2 == 0))
    res = ((res - 1) + MOD) % MOD;

  for (int i = 0; i < k-1; ++i)
    res /= 10;
  
  cout << res % 10 << ende;
  return 0;
}
