from pathlib import Path

dirs = [
    'algorithms',
    'misc',
    'contests',
    'problems'
]

# Returns a tree represented as dict, with structure of files
# and directories
def get_file_tree():
    tree = {}
    for di in dirs:
        path_list = Path(di).glob('**/*.cpp')

        for path in path_list:
            branch = str(path).split('/')

            curr = tree
            for i in branch[:-2]:
                if not i in curr:
                    curr[i] = {}
                curr = curr[i]

            if not branch[-2] in curr:
                curr[branch[-2]] = []
            curr[branch[-2]].append(str(branch[-1]))

    return tree

# Print elements in arr in Latex format
def gen_code_latex(arr, depth):
    for i in arr:
        print('\\' + depth + '{' + i + '}')

# Generate Latex from tree
def gen_latex(tree):
    stack = [ (tree, 0) ]
    depth = ['chapter', 'section', 'subsection']

    while len(stack) != 0:
        x, h = stack.pop()
        print(x)
        #if type(x) == list:
        #    gen_code_latex(x, depth[h])

        #print('\\' + depth[h] + '{' + i + '}')
        for i in x:
            stack.append((x[i], h + 1))
    


tree = get_file_tree()
for i in tree:
    print(i)
    for j in tree[i]:
        print('\t' + j)
        if type(tree[i]) != list:
            for k in tree[i][j]:
                print('\t\t' + k)
            print()
    print()
#print(tree)
#gen_latex(tree)
